********************************************************************************
*                                                                              *
*            Direct-methods for Incommensurate Modulated Structures            *
*                                                                              *
*                                  Original:                                   *
*                      by Fu Zheng-qing, 15 January 1992                       *
*      Institute of Physics, Chinese Academy of Sciences, Beijing, China       *
*                                                                              *
*                                   Revised:                                   *
*                 by Fan Hai-fu, 17 September - 14 October 1992                *
*                                 on visiting                                  *
*    Laboratory of Crystallography, University of Nijmegen, The Netherlands    *
*                                                                              *
********************************************************************************
      CHARACTER TITLE*80,TTIME*8,DDATE*9,DOT*1,SPACE*1
      CHARACTER*16 FILE_IN,FILE_OUT,FILE_REFL,FILE_SGM2
      LOGICAL ALL
C
      INTEGER*2 MMM(1000),IREL(600,1000)
      INTEGER*2 MARK(1000),NNNSYM(1000)
      INTEGER*2 HS(4,1000),HM(4,1000),H4S(10000)
      INTEGER*2 HSUM(3),OMIGS(3),MX(4,4,60)
      INTEGER*2 IATOM(50),ZATOM(50),NSETRC(100),NDIFID(1000)
      INTEGER*2 PHS(2,10000),PHM(2,10000)
      INTEGER*2 PHSATE(1000),PHMAIN(1000),PHSATE0(1000),PHNF(1000)
      INTEGER*2 ZER,ZERPI,PI,ICENT,RADIUS,PORID(4)
      INTEGER*4 H123S(10000),H123M(10000),H(4),RECORD
      REAL KPMAX,KPMIN
      COMMON /CZ0/NDIM,ISTD,MFS,MFSGO,ZERPI,ZER,PI,NRTOTAL
      COMMON /CZ1/HSUM,OMIGS,H,RADIUS,PORID
      COMMON /CZ2/MREL,MREL2,KPMAX,EMKAPMIN,ESKAPMIN,KPMIN,ISIGMA2
      COMMON /CZ3/NTRIAL,ISKIP,W1,W2,W3,MAXCYCL,CYCLCTR,PZPER
      COMMON /CZ4/ICOMP,INDIC,IOVER,NSETRC
      COMMON /CZ5/NATOM,ZATOM,IATOM,SGM23
      COMMON /CZ10/WT(1000),WTM(1000)
      COMMON /RFLX/  NREFS,NREFM,NRSATE,NRMAIN
      COMMON /RFLXM/ HM,EM(1000),FM(1000),SIGFM(1000),PHMAIN,PHM,H123M
      COMMON /RFLXS/ HS,ES(1000),FS(1000),SIGFS(1000),PHSATE,PHS,H123S
     *              ,H4S,PHSATE0
      COMMON /CZ13/EMAXS
      COMMON /CZ14/IREL,MMM,TOTREL
      COMMON /CZ15/SINT(0:450),COST(0:450)
      COMMON /CZ16/IXR,IYR,NFSET,NSET,NFXST
      COMMON /CZ17/ABSFOM(100),PSIZ(100), RKARL(100),COFOM(100),
     *              ABSF(100),PSI(100),RKAR(100),PHNF,WTNF(1000)
      COMMON /CZ18/ABMAX,ABMIN,PSIMAX,PSIMIN,RKAMAX,RKAMIN
      COMMON /CZ19/MX,NRGEN,NSYM,TRANL(4,60),ICENT
      COMMON /CZ20/IALTER,NNNSYM
      COMMON /CZ21/MARK
      COMMON /CZ22/FILE_OUT,FILE_REFL,FILE_SGM2
 
      CYCLCTR=0.005
      IALTER=0
      ICOMP=1
      NDIM=4
      INDIC=0
      ISIGMA2=0
      ISKIP=0
      ISTD=0
      KPMAX=50.0
      KPMIN=0.2
      MFS=1
      MREL=300
      MAXCYCL=10
      NFSET=0
      NTRIAL=100
      RADIUS=0
      W1=0.0
      W2=1.6
      W3=1.4
      DO I=1,3
         HSUM(I)=0
         OMIGS(I)=0
      END DO
      WRITE(*,*)
      WRITE(*,10) '$Input-file: '
   10 FORMAT(A13)
      READ(*,20) FILE_IN
   20 FORMAT(A16)
      WRITE(*,*)
      CALL TIME(TTIME)
      CALL DATE(DDATE)
      WRITE(*,30) TTIME 
   30 FORMAT('                       *** DIMS started at  '
     *         ,A8,'  ***')
      LFILE_IN=LEN(FILE_IN)
      DOT='.'
      SPACE=' '
      INPER=0      
      DO 40 I=1,LFILE_IN
         IF(FILE_IN(I:I).EQ.DOT.OR.FILE_IN(I:I).EQ.SPACE) GOTO 50
   40 CONTINUE
   50 INPER=I-1
      FILE_OUT=FILE_IN(1:INPER)//'.OUT'
      FILE_REFL=FILE_IN(1:INPER)//'.PHASES'
      FILE_SGM2=FILE_IN(1:INPER)//'.SIGMA2'
      OPEN(1,FILE=FILE_IN,STATUS='OLD')
      OPEN(10,FILE=FILE_OUT,STATUS='UNKNOWN')
      OPEN(11,FILE=FILE_REFL,STATUS='UNKNOWN')
      OPEN(12,FILE=FILE_SGM2,FORM='UNFORMATTED',STATUS='UNKNOWN')
      WRITE(10,55) TTIME,DDATE
   55 FORMAT(' *** JOB started at  'A8,'  ',A9,'  ***')
      NATOM=0
      RECORD=0
      READ(1,'(A80)') TITLE
      RECORD=RECORD+1
      READ(1,*)
      RECORD=RECORD+1
      READ(1,*) ISTD,MFS,ISIGMA2,ZERPI,IDATA
      IF (MFS.LT.1) MFS=1
      IF (MFS.GT.2) MFS=2
      RECORD=RECORD+1
      READ(1,*)
      RECORD=RECORD+1
      READ(1,*) NTRIAL,ISKIP,INDIC,NFSET,NFSET2
      RECORD=RECORD+1
      READ(1,*)
      RECORD=RECORD+1
      READ(1,*) MAXCYCL,RADIUS
      RECORD=RECORD+1
      READ(1,*)
      RECORD=RECORD+1
      READ(1,*) W1,W2,W3
      RECORD=RECORD+1
      READ(1,*)
      RECORD=RECORD+1
      READ(1,*) MREL,KPMIN,KPMAX
      RECORD=RECORD+1
      READ(1,*)
         RECORD=RECORD+1
      DO I=1,120
         READ(1,*) IA,LZA
            RECORD=RECORD+1
         IF(IA.NE.0) THEN
            IATOM(I)=IA
            ZATOM(I)=LZA
            NATOM=NATOM+1
         ELSE
            GOTO 60 
         ENDIF
      END DO
   60 READ(1,*)
      RECORD=RECORD+1
      READ(1,*) NRGEN
      RECORD=RECORD+1
      DO I=1,NRGEN
         DO J=1,NDIM
            READ(1,*) (MX(J,K,I),K=1,NDIM),TRANL(J,I)
            RECORD=RECORD+1
         END DO
         READ(1,*)
         RECORD=RECORD+1
      END DO
      ICENT=0
      DO 70 I=1,NRGEN
         DO J=1,NDIM
            IF(MX(J,J,I).NE.-1) GOTO 70
         END DO
         ICENT=1
         GOTO 80
   70 CONTINUE
   80 IF(ICENT.EQ.0) THEN
         NRGEN=NRGEN+1
         DO I=1,NDIM
              DO J=1,NDIM
               MX(I,J,NRGEN)=0
              END DO
              TRANL(I,NRGEN)=0.0
         END DO
         DO I=1,NDIM
            MX(I,I,NRGEN)=-1
         END DO
      ELSE
      ENDIF
C
      CALL MATRIX
      MREL2=2*MREL
      ZER=0
      PI=180
      DTOR=ATAN(1.0)/45.0
      DO 90 I=0,450
         SINT(I)=SIN(DTOR*I)
         COST(I)=COS(DTOR*I)
  90  CONTINUE
      SG2=0.0
      SG3=0.0
      DO I=1,NATOM
         ZA2=ZATOM(I)*ZATOM(I)
         ZA3=ZATOM(I)*ZA2
         SG2=SG2+IATOM(I)*ZA2
         SG3=SG3+IATOM(I)*ZA3
      END DO
      SGM23=2.0*SG3/SQRT(SG2**3)
      IF (MFS.EQ.2) THEN
         MFSGO=1
         MFS=MFS-1
      ELSE
         MFSGO=0
      ENDIF
  100 IOVER=0
      WRITE(10,110) MFS
  110 FORMAT(1X,'PHASING RESULTS FOR SATELLITES WITH M =',I2) 
      WRITE(10,'(A80)') TITLE
      WRITE(10,120) NTRIAL,ISKIP,MAXCYCL
  120 FORMAT(1X,'NUMBER OF TRIALS=',I3,5X,
     *  'THE FIRST',I4,' SETS WERE SKIPPED'/1X,
     *  'TOTAL NUMBER OF CYCLES FOR EACH TRIAL=',I3)
      WRITE(10,130) W1,W2,W3,KPMIN,KPMAX
  130 FORMAT(1X,'WEIGHTS FOR FIGURES OF MERIT:'/5X,
     *  'W1=',F5.3,5X,'W2=',F5.3,5X,'W3=',F5.3/1X,
     *  'KAPA-MINIMUM=',F4.2,5X,'KAPA-MAXIMUM=',F16.2)
      WRITE(10,140)
  140 FORMAT(1X,'-----------------------------------------------')
      WRITE(10,*)
      WRITE(10,*)
C      INPUT INDEPENDENT REFLECTIONS AND CALCULATE SCALED FOBS
      NRSATE=0
      NRMAIN=0
      NRTOTAL=0
      SUMFM=0.0
      SUMFS=0.0
      RTD=45.0/ATAN(1.0)
      DO 150 I=1,2000
         READ(1,'(1X,4I3,F9.4,F7.2)',END=160)
     *         (H(J),J=1,NDIM),FOBS,PHAZ
         IF (RADIUS.EQ.1) PHAZ=PHAZ*RTD
         NRTOTAL=NRTOTAL+1
         IF (H(4).EQ.0) THEN
            NRMAIN=NRMAIN+1
            DO JI=1,NDIM
               HM(JI,NRMAIN)=H(JI)
            END DO
            PHMAIN(NRMAIN)=PHAZ
            FM(NRMAIN)=FOBS
            SIGFM(NRMAIN)=SGMFOBS
            SUMFM=SUMFM+FOBS
         ELSEIF (IABS(H(4)).EQ.MFS) THEN
            NRSATE=NRSATE+1
            DO JI=1,NDIM
               HS(JI,NRSATE)=H(JI)
            END DO
            PHSATE(NRSATE)=PHAZ
            FS(NRSATE)=FOBS
            SIGFS(NRSATE)=SGMFOBS
            SUMFS=SUMFS+FOBS
         ELSE
         ENDIF
  150 CONTINUE
C
C      CALCULATE SCALED-FOBS
  160 SCALE=1.0
      IF (IDATA.EQ.1) THEN
         FMAIN=SUMFM/NRMAIN
         FSATE=SUMFS/NRSATE
         SCBOT=(SGM23*FMAIN*FSATE*FSATE)**(1.0/3.0)
         SCALE=1.0/SCBOT
      ENDIF
      DO I=1,NRMAIN
         EM(I)=FM(I)*SCALE
      END DO
      DO I=1,NRSATE
         ES(I)=FS(I)*SCALE
      END DO
C
C     SORT SATELLITES IN DESCENDING ORDER OF E VALUES
      NUMB=NRSATE
  170 IF(NUMB.LE.1) GOTO 200
      NUMB=NUMB/2
      IEND=NRSATE-NUMB
  180 ALL=.TRUE.
      DO 190 ITOP=1,IEND
         IBOT=ITOP+NUMB
         X=ES(IBOT)
         Y=ES(ITOP)
         IF(X.LE.Y) GOTO 190
         EES=ES(ITOP)
         ES(ITOP)=ES(IBOT)
         ES(IBOT)=EES
         EES=FS(ITOP)
         FS(ITOP)=FS(IBOT)
         FS(IBOT)=EES
         EES=SIGFS(ITOP)
         SIGFS(ITOP)=SIGFS(IBOT)
         SIGFS(IBOT)=EES
         IHH0=PHSATE(ITOP)
         PHSATE(ITOP)=PHSATE(IBOT)
         PHSATE(IBOT)=IHH0
         DO  I=1,NDIM
            IHH0=HS(I,ITOP)
            HS(I,ITOP)=HS(I,IBOT)
            HS(I,IBOT)=IHH0
         END DO
         ALL=.FALSE.
  190 CONTINUE
      IF (.NOT.ALL) THEN
         GOTO 180
      ELSE
         GOTO 170
      ENDIF
      GOTO 170
C
  200 EMAXS=ES(1)
C     SORT MAIN REFLECTIONS IN DESCENDIND ORDER OF E VALUES
      NUMB=NRMAIN
1400   IF(NUMB.LE.1) GOTO 148
      NUMB=NUMB/2
      IEND=NRMAIN-NUMB
144   ALL=.TRUE.
      DO 145 ITOP=1,IEND
         IBOT=ITOP+NUMB
         X=EM(IBOT)
         Y=EM(ITOP)
         IF(X.LE.Y) GOTO 145
         EES=EM(ITOP)
         EM(ITOP)=EM(IBOT)
         EM(IBOT)=EES
         EES=FM(ITOP)
         FM(ITOP)=FM(IBOT)
         FM(IBOT)=EES
         EES=SIGFM(ITOP)
         SIGFM(ITOP)=SIGFM(IBOT)
         SIGFM(IBOT)=EES
         IHH0=PHMAIN(ITOP)
         PHMAIN(ITOP)=PHMAIN(IBOT)
         PHMAIN(IBOT)=IHH0
         DO  I=1,NDIM
            IHH0=HM(I,ITOP)
            HM(I,ITOP)=HM(I,IBOT)
            HM(I,IBOT)=IHH0
         END DO
         ALL=.FALSE.
145   CONTINUE
      IF(.NOT.ALL) THEN
         GOTO 144
      ELSE
         GOTO 1400
      ENDIF
         GOTO 1400
148   ESKAPMIN=KPMIN*ES(NRSATE/2)
      EMKAPMIN=KPMIN*EM(NRMAIN/2)
      PSNO=FLOAT(NRSATE)/10.0
      NFORPS=NRSATE-INT(PSNO)
      PZPER=ES(NFORPS)/EMAXS
      CALL RINDW
      TOTREL=0.0
      IF (ISIGMA2.EQ.0) THEN
         CALL SIGMA2
      ELSE
         DO I=1,NRSATE
            READ(12) MMM(I),(IREL(J,I),J=1,2*MMM(I))
            TOTREL=TOTREL+MMM(I)
         END DO
      ENDIF
      IF (ISTD.EQ.1) THEN
         DO I=1,NRSATE
            PHSATE0(I)=PHSATE(I)
         END DO
      ELSE
      ENDIF
      IF(INDIC.EQ.1) THEN
         IF(MFSGO.EQ.1) THEN
            ISKIP=NFSET-1
         ELSE
            ISKIP=NFSET2-1
         ENDIF
         NFXST=1
          NTRIAL=1
         IOVER=1
      ELSE
      ENDIF
174      IXR=1
      IYR=1
      IXR2=2511
      IYR2=2511
      IF(ISKIP.GE.1) THEN
           DO 168 I=1,ISKIP
              DO 167 J=1,NRSATE
                 PMIL=RAND(IXR,IYR)
                 IF(ICENT.NE.1) THEN
                    PMIL=RAND(IXR2,IYR2)
                 ELSE
                 ENDIF
167           CONTINUE
168        CONTINUE
      ELSE
      ENDIF
      DO II=1,NRMAIN
            WTM(II)=1.0
      END DO
2     DO 1700 I=1,NTRIAL
         IORP=3
         NSET=I
         NSETRC(NSET)=NSET
         DO 1600 II=1,NRSATE
            IPHA=90.0-90.0*SIGN(1.0,(RAND(IXR,IYR)-0.5))
            IF (ICENT.EQ.1) THEN
               PHSATE(II)=IPHA
            ELSE
               PHSATE(II)=IPHA+45.0*SIGN(1.0,(RAND(IXR2,IYR2)-0.5))
            ENDIF
            WT(II)=0.25
 1600    CONTINUE
         PSIZ(NSET)=0.0
         PSI(NSET)=0.0
         CALL PHATAN
 1700 CONTINUE
      IF(IOVER.EQ.1) GOTO 151
      CALL CFOM
      WRITE(10,*)
      WRITE(10,*)
      WRITE(10,*)
      NFXST=1
      ISKIPSEC=ISKIP
      ISKIP=ISKIP+NSETRC(NFXST)-1
      NSETSEC=NTRIAL
      NTRIAL=1
      IOVER=1
      GOTO 174            
151      DO I=1,NRSATE
         ES(I)=ES(I)*MARK(I)
      END DO
      IF (ISTD.EQ.1) THEN
         IF(MFS.EQ.1) THEN
            DO II=1,NRMAIN
               WRITE(10,6287) (HM(K,II),K=1,NDIM),FM(II),EM(II),
     *                 PHMAIN(II)
            END DO
         ELSE
         ENDIF
         WRITE(10,*)
C         COMPARE THE REAL PHASES AND PHASING RESUL OR NOT
         IF(ICOMP.EQ.1) THEN
           WRITE(10,6275) (NSETRC(NFXST)+ISKIP),COFOM(NFXST)
6275           FORMAT(1X,'**** COMPARATION BTWEEN REAL&PHASING-',
     *               'RESULT ****    SET NO.:',I3,
     *               '   COFOM=',F5.3)
           WRITE(10,6283)
           NDIF=0
           DO 6280 II=1,NRSATE
              NDIFID(II)=0
                IF(PHSATE0(II).EQ.PHSATE(II)) GOTO 6280
             NDIF=NDIF+1
             NDIFID(II)=-1  
6280          CONTINUE
           DO II=1,NRSATE
            WRITE(10,6285) (HS(K,II),K=1,NDIM),FS(II),ES(II),
     *             PHSATE0(II),PHSATE(II),NDIFID(II)
           END DO
           WRITE(10,6286) NDIF
        ELSE
        ENDIF
      ELSE
         WRITE(10,6276) (NSETRC(NFXST)+ISKIP),COFOM(NFXST)
6276         FORMAT(1X,'**** PHASING-',
     *               'RESULT ****    SET NO.:',I3,
     *               '   COFOM=',F5.3)
         WRITE(10,*)
         WRITE(10,6284)
C-------OUTPUT THE MAIN-REFS
        IF(MFS.NE.0) THEN
            DO II=1,NRMAIN
               WRITE(10,6287) (HM(K,II),K=1,NDIM),FM(II),EM(II),
     *                    PHMAIN(II)
            END DO
        ELSE
        ENDIF
C-------OUTPUT THE SATELITE-REFS
        DO II=1,NRSATE
            WRITE(10,6287) (HS(K,II),K=1,NDIM),FS(II),ES(II),
     *                    PHSATE(II)
        END DO
      ENDIF
C-2-----FOR FOURIER MAP
      IF(MFS.NE.2) THEN
         IF(MFS.NE.0) THEN
            IF(MFSGO.EQ.1) THEN
               NRTOTAL=NRTOTAL
            ELSE
               NRTOTAL=NRSATE+NRMAIN
            ENDIF
            WRITE(11,*) NRTOTAL
            DO II=1,NRMAIN
               WRITE(11,6288) (HM(K,II),K=1,NDIM),FM(II),
     *                          SIGFM(II),PHMAIN(II)
            END DO
         ELSE
            WRITE(11,*) NRSATE
         ENDIF
      ELSE
      ENDIF
      DO II=1,NRSATE
         WRITE(11,6289) (HS(K,II),K=1,NDIM),FS(II),
     *                 SIGFS(II),PHSATE(II),MARK(II)
      END DO
      IF(MFSGO.EQ.1) THEN
         WRITE(10,*)
         WRITE(10,*)
         WRITE(10,*)
      ELSE
      ENDIF
6283  FORMAT(1X,'   H1   H2   H3   H4        ',
     *         'FS        ES   PHSATE   PHAS',
     *         '   DIFID')
6284  FORMAT(1X,'   H1   H2   H3   H4        ',
     *         'FS        ES    PHAS')
6285  FORMAT(1X,4I5,F10.4,F12.5,3I6)
6287  FORMAT(1X,4I5,F10.2,F10.4,I7)
6288  FORMAT(1X,4I5,F10.2,F8.2,I7)
6289  FORMAT(1X,4I5,F10.2,F8.2,I7,I5)
6286  FORMAT(1x,'Differences-No.:',I4)
      IF(MFSGO.EQ.1) THEN
         MFS=MFS+1
         MFSGO=0
         NTRIAL=NSETSEC
         ISKIP=ISKIPSEC
         REWIND(1)
         DO I=1,RECORD
            READ(1,*)
         END DO
         GOTO 100
      ELSE
      ENDIF
      CALL END_JOB
      WRITE(*,*)      
      STOP '                              --------------------'
      END
C      *** A FUNCTION FOR RANDOM NUMBER ***
      FUNCTION RAND (IX,IY)
      IX = MOD(251*IX,1048576)
      IY = MOD(179*IY,1048576)
      RAND = FLOAT (MOD(IX+IY,1048576))/1048576.0
      RETURN
      END
C      *** SUB ***
      SUBROUTINE HPACK(H,IPACK)
      INTEGER*4 H(4)
         IPACK=H(1)*256*256+
     *               H(2)*256+
     *               H(3)
      RETURN
      END
C      *** SUB ***
      SUBROUTINE RINDW
      LOGICAL ALL
      INTEGER*2 MMM(1000),IREL(600,1000)
      INTEGER*2 MARK(1000),NNNSYM(1000)
      INTEGER*2 HS(4,1000),HM(4,1000),H4S(10000)
      INTEGER*2 HSUM(3),OMIGS(3),MX(4,4,60)
      INTEGER*2 IATOM(50),ZATOM(50),NSETRC(100)
      INTEGER*2 PHS(2,10000),PHM(2,10000)
      INTEGER*2 PHSATE(1000),PHMAIN(1000),PHSATE0(1000),PHNF(1000)
      INTEGER*2 ZER,ZERPI,PI,ICENT,RADIUS,PORID(4)
      INTEGER*4 H123S(10000),H123M(10000),IPACK,H(4)
      REAL KPMAX,KPMIN
      COMMON /CZ0/NDIM,ISTD,MFS,MFSGO,ZERPI,ZER,PI,NRTOTAL
      COMMON /CZ1/HSUM,OMIGS,H,RADIUS,PORID
      COMMON /CZ2/MREL,MREL2,KPMAX,EMKAPMIN,ESKAPMIN,KPMIN,ISIGMA2
      COMMON /CZ3/NTRIAL,ISKIP,W1,W2,W3,MAXCYCL,CYCLCTR,PZPER
      COMMON /CZ4/ICOMP,INDIC,IOVER,NSETRC
      COMMON /CZ5/NATOM,ZATOM,IATOM,SGM23
      COMMON /CZ10/WT(1000),WTM(1000)
      COMMON /RFLX/  NREFS,NREFM,NRSATE,NRMAIN
      COMMON /RFLXM/ HM,EM(1000),FM(1000),SIGFM(1000),PHMAIN,PHM,H123M
      COMMON /RFLXS/ HS,ES(1000),FS(1000),SIGFS(1000),PHSATE,PHS,H123S
     *              ,H4S,PHSATE0
      COMMON /CZ13/EMAXS
      COMMON /CZ14/IREL,MMM,TOTREL
      COMMON /CZ15/SINT(0:450),COST(0:450)
      COMMON /CZ16/IXR,IYR,NFSET,NSET,NFXST
      COMMON /CZ17/ABSFOM(100),PSIZ(100), RKARL(100),COFOM(100),
     *              ABSF(100),PSI(100),RKAR(100),PHNF,WTNF(1000)
      COMMON /CZ18/ABMAX,ABMIN,PSIMAX,PSIMIN,RKAMAX,RKAMIN
      COMMON /CZ19/MX,NRGEN,NSYM,TRANL(4,60),ICENT
      COMMON /CZ20/IALTER,NNNSYM
      COMMON /CZ21/MARK
 
      NRE=0
      NREFS=1
      DO 2100 I=1,NRSATE
         NNNSYM(I)=0
         DO 2200 J=1,NSYM
            DO 2300 K=1,NDIM
               H(K)=0
               DO 2400 L=1,NDIM
                  H(K)=H(K)+HS(L,I)*MX(L,K,J)
2400               CONTINUE
2300            CONTINUE
            CALL HPACK(H,IPACK)
            PPTR=0.0
            DO IPTR=1,NDIM
               PPTR=PPTR+HS(IPTR,I)*TRANL(IPTR,J)
            END DO
            DO 2020 IJK=NREFS,NRE
             IF(IPACK.EQ.H123S(IJK).AND.H(4).EQ.H4S(IJK)) GOTO 2200
2020            CONTINUE
            NRE=NRE+1
            NNNSYM(I)=NNNSYM(I)+1
            H123S(NRE)=IPACK
            H4S(NRE)=H(4)
            PHS(1,NRE)=I
            PHS(2,NRE)=PPTR*360.0
2200  CONTINUE
      NREFS=NRE
2100  CONTINUE
      NREFS=NRE
C
      NRE=0
      NREFM=1
      DO 2101 I=1,NRMAIN
         DO 2201 J=1,NSYM
            DO 2301 K=1,NDIM
               H(K)=0
               DO 2401 L=1,NDIM
                  H(K)=H(K)+HM(L,I)*MX(L,K,J)
2401               CONTINUE
2301            CONTINUE
            CALL HPACK(H,IPACK)
            PPTR=0.0
            DO IPTR=1,NDIM
               PPTR=PPTR+HM(IPTR,I)*TRANL(IPTR,J)
            END DO
            DO 2021 M=NREFM,NRE
            IF(IPACK.EQ.H123M(M).AND.H(4).EQ.0) GOTO 2201
2021            CONTINUE
            NRE=NRE+1
            H123M(NRE)=IPACK
            PHM(1,NRE)=I
            PHM(2,NRE)=PPTR*360.0
2201  CONTINUE
      NREFM=NRE
2101  CONTINUE
      NREFM=NRE
C
      NUMB=NREFS
130      IF(NUMB.LE.1) GOTO 128
      NUMB=NUMB/2
      IEND=NREFS-NUMB
134      ALL=.TRUE.
      DO 135 ITOP=1,IEND
         IBOT=ITOP+NUMB
         Y=H123S(IBOT)
         X=H123S(ITOP)
         IF(X.LE.Y) GOTO 135
         IHH0=H123S(ITOP)
         H123S(ITOP)=H123S(IBOT)
         H123S(IBOT)=IHH0
         IHH0=H4S(ITOP)
         H4S(ITOP)=H4S(IBOT)
         H4S(IBOT)=IHH0
         IHH0=PHS(1,ITOP)
         PHS(1,ITOP)=PHS(1,IBOT)
         PHS(1,IBOT)=IHH0
         IHH0=PHS(2,ITOP)
         PHS(2,ITOP)=PHS(2,IBOT)
         PHS(2,IBOT)=IHH0         
         ALL=.FALSE.
135   CONTINUE
      IF(.NOT.ALL) THEN
         GOTO 134
      ELSE
         GOTO 130
      ENDIF
      GOTO 130
C
128   NUMB=NREFM
1301  IF(NUMB.LE.1) GOTO 1281
      NUMB=NUMB/2
      IEND=NREFM-NUMB
1341      ALL=.TRUE.
      DO 1351 ITOP=1,IEND
         IBOT=ITOP+NUMB
         Y=H123M(IBOT)
         X=H123M(ITOP)
         IF(X.LE.Y) GOTO 1351
         IHH0=H123M(ITOP)
         H123M(ITOP)=H123M(IBOT)
         H123M(IBOT)=IHH0
         IHH0=PHM(1,ITOP)
         PHM(1,ITOP)=PHM(1,IBOT)
         PHM(1,IBOT)=IHH0
         IHH0=PHM(2,ITOP)
         PHM(2,ITOP)=PHM(2,IBOT)
         PHM(2,IBOT)=IHH0         
         ALL=.FALSE.
1351  CONTINUE
      IF(.NOT.ALL) THEN
         GOTO 1341
      ELSE
         GOTO 1301
      ENDIF
      GOTO 1301
1281  RETURN
      END
C      *** SUB ***
      SUBROUTINE SIGMA2
      LOGICAL ALL
      INTEGER*2 MMM(1000),IREL(600,1000)
      INTEGER*2 MARK(1000),NNNSYM(1000)
      INTEGER*2 HS(4,1000),HM(4,1000),H4S(10000)
      INTEGER*2 HSUM(3),OMIGS(3),MX(4,4,60)
      INTEGER*2 IATOM(50),ZATOM(50),NSETRC(100)
      INTEGER*2 PHS(2,10000),PHM(2,10000)
      INTEGER*2 PHSATE(1000),PHMAIN(1000),PHSATE0(1000),PHNF(1000)
      INTEGER*2 ZER,ZERPI,PI,ICENT,RADIUS,PORID(4)
      INTEGER*4 H123S(10000),H123M(10000),INDEX,H(4)
      REAL KPMAX,KPMIN
      COMMON /CZ0/NDIM,ISTD,MFS,MFSGO,ZERPI,ZER,PI,NRTOTAL
      COMMON /CZ1/HSUM,OMIGS,H,RADIUS,PORID
      COMMON /CZ2/MREL,MREL2,KPMAX,EMKAPMIN,ESKAPMIN,KPMIN,ISIGMA2
      COMMON /CZ3/NTRIAL,ISKIP,W1,W2,W3,MAXCYCL,CYCLCTR,PZPER
      COMMON /CZ4/ICOMP,INDIC,IOVER,NSETRC
      COMMON /CZ5/NATOM,ZATOM,IATOM,SGM23
      COMMON /CZ10/WT(1000),WTM(1000)
      COMMON /RFLX/  NREFS,NREFM,NRSATE,NRMAIN
      COMMON /RFLXM/ HM,EM(1000),FM(1000),SIGFM(1000),PHMAIN,PHM,H123M
      COMMON /RFLXS/ HS,ES(1000),FS(1000),SIGFS(1000),PHSATE,PHS,H123S
     *              ,H4S,PHSATE0
      COMMON /CZ13/EMAXS
      COMMON /CZ14/IREL,MMM,TOTREL
      COMMON /CZ15/SINT(0:450),COST(0:450)
      COMMON /CZ16/IXR,IYR,NFSET,NSET,NFXST
      COMMON /CZ17/ABSFOM(100),PSIZ(100), RKARL(100),COFOM(100),
     *              ABSF(100),PSI(100),RKAR(100),PHNF,WTNF(1000)
      COMMON /CZ18/ABMAX,ABMIN,PSIMAX,PSIMIN,RKAMAX,RKAMIN
      COMMON /CZ19/MX,NRGEN,NSYM,TRANL(4,60),ICENT
      COMMON /CZ20/IALTER,NNNSYM
      COMMON /CZ21/MARK
 
      TOTREL=0.0
      LGOON=1
      DO I=1,NRSATE
         MARK(I)=1
      END DO
3400  KPMAX=KPMAX/SGM23
      ESKAPMIN=KPMIN*ES(NRSATE/2)
      EMKAPMIN=KPMIN*EM(NRMAIN/2)
3501  DO 3500 I=LGOON,NRSATE
         MM=0
         SKAPAM=ES(I)*EMKAPMIN*ESKAPMIN
         DO J=1,NDIM
            H(J)=HS(J,I)
         END DO
         CALL HPACK(H,INDEX)
         IND1=1
         IND2=NREFM
         IF(H4S(IND1)-H(4)) 3120,3025,3120
3025         IF(H123M(IND2)+H123S(IND1)-INDEX) 3120,3200,3120 
3120         IND1=IND1+1
         IF(IND1.GT.NREFS) GOTO 3260
3140         IF(H4S(IND1)-H(4)) 3120,3121,3120
3121         IF(H123M(IND2)+H123S(IND1)-INDEX) 3120,3200,3180 
3180         IND2=IND2-1
         IF(IND2.LE.0) GOTO 3260
         GOTO 3140
3200         IM=PHM(1,IND2)
         IS=PHS(1,IND1)
         SKAPA=ES(I)*EM(IM)*ES(IS)
         IF(SKAPA.LT.SKAPAM.OR.SKAPA.GT.KPMAX) GOTO 3320
         MM=MM+1
         N2=2*MM
         N1=N2-1
         IREL(N1,I)=IND1
         IREL(N2,I)=IND2
         IF(MM.GE.MREL) GOTO 3260
3320         GOTO 3120 
3260         MMM(I)=MM
         IF(MMM(I).LE.0) THEN
           CALL ERR2(H,I,LGOON,KPMAX,KPMIN,MFS,SGM23,*3400)
         ELSE
         ENDIF
         TOTREL=TOTREL+MMM(I)
         WRITE(12) MMM(I),(IREL(IC,I),IC=1,2*MMM(I))
3500  CONTINUE
      KPMAX=KPMAX*SGM23
      RETURN
      END
C
      SUBROUTINE ERR2(H,I,LGOON,KPMAX,EKAPER,MFS,SGM23,*)
      CHARACTER*1 YN,YN1,YN2,YN3,YN4
      INTEGER*2 MARK(1000)
      INTEGER*4 H(4)
      REAL KPMAX,KPMIN
      COMMON /CZ21/MARK
      YN1='Y'
      YN2='y'
      YN3='N'
      YN4='n'
      WRITE(*,*)
      WRITE(*,*) '# KAPA-MINIMUM too large or KAPA-MAXIMUM too small.'
      WRITE(*,*) '  No sigma-2 relationships found for the',
     *                ' following satellite reflection.'
      WRITE(*,10) I,(H(J),J=1,4)
10    FORMAT(1X,'  Nr:',I4,'    HKLM:',4I4)
1     WRITE(*,*)
      WRITE(*,*) '# Ignore?'
      WRITE(*,*) '  If Yes, the phase of it will NOT be derived and',
     *' a RANDOM value' 
      WRITE(*,20)'$  will be ASSIGNED to it as the final result (Y/N)? '
20    FORMAT(A53)
      READ(*,'(A)') YN
      WRITE(*,*)
      IF(YN.EQ.YN1.OR.YN.EQ.YN2) THEN
         MARK(I)=-1
         LGOON=I+1
         WRITE(10,30) (H(J),J=1,4)
30         FORMAT(' # REFLECTION (HKLM):',4I4,
     *              ' is neglected in the phasing procedure')
            RETURN 1
      ELSEIF(YN.EQ.YN3.OR.YN.EQ.YN4) THEN
         WRITE(*,*) '# Please give a smaller KPMIN or a larger KPMAX.'
         KPMAX=KPMAX*SGM23
         WRITE(*,40) EKAPER,KPMAX
         WRITE(*,*)
40       FORMAT('   Current values of KPMIN and KPMAX:',F10.2,F18.3)
         WRITE(*,42) '$  New KPMIN: '
42       FORMAT(A14)
         READ (*,*) EKAPER
         WRITE(*,42) '$  New KPMAX: '
         READ(*,*) KPMAX
         WRITE(10,50) EKAPER,KPMAX
50       FORMAT(' # Your new KPMIN and KPMAX: ',F5.3,F18.3,
     *            ' is used from')
         WRITE(10,60) (H(J),J=1,4)
60         FORMAT('    the reflection (HKLM): ',4I4,'  and on!')
         LGOON=I
         RETURN 1
      ELSE
         WRITE(*,*) '# Incorrect answer, input again!'
         GOTO 1
      ENDIF
      RETURN
      END
C     PHASING PROGRAM
      SUBROUTINE PHATAN
      LOGICAL ALL
      INTEGER*2 MMM(1000),IREL(600,1000)
      INTEGER*2 MARK(1000),NNNSYM(1000)
      INTEGER*2 HS(4,1000),HM(4,1000),H4S(10000)
      INTEGER*2 HSUM(3),OMIGS(3),MX(4,4,60)
      INTEGER*2 IATOM(50),ZATOM(50),NSETRC(100)
      INTEGER*2 PHS(2,10000),PHM(2,10000)
      INTEGER*2 PHSATE(1000),PHMAIN(1000),PHSATE0(1000),PHNF(1000)
      INTEGER*2 ZER,ZERPI,PI,ICENT,FINE,RADIUS,PORID(4)
      INTEGER*4 H123S(10000),H123M(10000),H(4)
      REAL KPMAX,KPMIN,ECAL(1000)
      COMMON /CZ0/NDIM,ISTD,MFS,MFSGO,ZERPI,ZER,PI,NRTOTAL
      COMMON /CZ1/HSUM,OMIGS,H,FINE,RADIUS,PORID
      COMMON /CZ2/MREL,MREL2,KPMAX,EMKAPMIN,ESKAPMIN,KPMIN,ISIGMA2
      COMMON /CZ3/NTRIAL,ISKIP,W1,W2,W3,MAXCYCL,CYCLCTR,PZPER
      COMMON /CZ4/ICOMP,INDIC,IOVER,NSETRC
      COMMON /CZ5/NATOM,ZATOM,IATOM,SGM23
      COMMON /CZ10/WT(1000),WTM(1000)
      COMMON /RFLX/  NREFS,NREFM,NRSATE,NRMAIN
      COMMON /RFLXM/ HM,EM(1000),FM(1000),SIGFM(1000),PHMAIN,PHM,H123M
      COMMON /RFLXS/ HS,ES(1000),FS(1000),SIGFS(1000),PHSATE,PHS,H123S
     *              ,H4S,PHSATE0
      COMMON /CZ13/EMAXS
      COMMON /CZ14/IREL,MMM,TOTREL
      COMMON /CZ15/SINT(0:450),COST(0:450)
      COMMON /CZ16/IXR,IYR,NFSET,NSET,NFXST
      COMMON /CZ17/ABSFOM(100),PSIZ(100), RKARL(100),COFOM(100),
     *              ABSF(100),PSI(100),RKAR(100),PHNF,WTNF(1000)
      COMMON /CZ18/ABMAX,ABMIN,PSIMAX,PSIMIN,RKAMAX,RKAMIN
      COMMON /CZ19/MX,NRGEN,NSYM,TRANL(4,60),ICENT
      COMMON /CZ20/IALTER,NNNSYM
      COMMON /CZ21/MARK
 
      NRELIS=MAXCYCL
      NCYCCTR=1
      NCYCL=1
      PHCTR=0.0
      IPHCTR1=0
      IPHCTR2=0
      SGM0=0.5*SGM23
         NSET0=NSET+ISKIP
      IF (ISTD.EQ.1) THEN
5009     WRITE(10,5001)
         WRITE(10,5002) NSET0
5002         FORMAT(1X,I6)
5001         FORMAT(1X,'SETNO.      CYCLNO.     DIFNO.')
      ELSE
      ENDIF
5010  DO 5000  I=1,NRSATE
         IF(MARK(I).LT.0) GOTO 5000
5015     TH=0.0
         BH=0.0
         DO 5100 ITH=1,MMM(I)
            JTH=2*ITH
            IR1=IREL(JTH-1,I)
            IR2=IREL(JTH,I)
            JM1=PHS(1,IR1)
            JM2=PHM(1,IR2)
            IPHASAT=PHSATE(JM1)+PHS(2,IR1)
            IPHMA=PHMAIN(JM2)+PHM(2,IR2)
            IPHHP=IPHASAT+IPHMA
            EHHP=ES(JM1)*EM(JM2)
            IPHHP=MOD(IPHHP,360)+360
            IPHHP=MOD(IPHHP,360)
            WEHP=WT(JM1)*WTM(JM2)*EHHP
            TH=TH+WEHP*SINT(IPHHP)
            BH=BH+WEHP*COST(IPHHP)
5100         CONTINUE
         XP=ES(I)*SQRT(TH*TH+BH*BH)
         IF(ICENT.EQ.1) THEN
            IF(BH.GE.0.0) THEN
               IPHASN=0
            ELSE
               IPHASN=180
            ENDIF
         ELSE
            IF(BH.NE.0) THEN
               PHASN=ATAN2(TH,BH)
               IPHASN=INT(PHASN*57.3)
            ELSE
               IF(TH.GE.0) THEN
                  IPHASN=90
               ELSE
                  IPHASN=270
               ENDIF
            ENDIF
         ENDIF
         BP=SGM0*XP
         WTN=TANH(BP)
5025         IF(NCYCL.GT.NCYCCTR) THEN
            IPHCTR1=IABS(IPHASN-PHSATE(I))
            IPHCTR2=MAX(IPHASN,PHSATE(I))
            IF(IPHCTR2.NE.0) THEN
               PHCTR=PHCTR+IPHCTR1/IPHCTR2
            ELSE
            ENDIF
         ELSE
         ENDIF
C        WITH IALTER.NE.1 EACH NEW PHASE AND WT WILL BE USED
C            IN PHASING THE NEXT REFLECTIONS
         IF(IALTER.EQ.1) THEN
            PHNF(I)=IPHASN
            WTNF(I)=WTN
         ELSE
            PHSATE(I)=IPHASN
            WT(I)=WTN
         ENDIF
5000  CONTINUE
      IF(IALTER.EQ.1) THEN
         DO I=1,NRSATE
            PHSATE(I)=PHNF(I)
            WT(I)=WTNF(I)
         END DO
      ELSE
      ENDIF
      IF(NCYCL.GT.NCYCCTR) THEN
         CYCCTR=PHCTR*100.0/NRSATE**2*100.0/NRSATE**2
      ELSE
      ENDIF
      IF (ISTD.EQ.1) THEN
         NDIF=0
         DO 5301 II=1,NRSATE
            IF(PHSATE0(II).EQ.IABS(PHSATE(II))) GOTO 5301
            NDIF=NDIF+1
5301         CONTINUE
         WRITE(10,5305) NCYCL,NDIF
5305         FORMAT(1X,10X,I6,6X,I6)
      ELSE
      ENDIF
      IF(NCYCL.GT.NCYCCTR) THEN
         IF(CYCCTR.LE.CYCLCTR) GOTO 5329
         PHCTR=0.0
         IPHCTR1=0
         IPHCTR2=0
      ELSE
      ENDIF
      NCYCL=NCYCL+1
      IF(NCYCL.GT.MAXCYCL) GOTO 5329
      GOTO 5010
5329  IF (ISTD.EQ.1) THEN
      WRITE(10,*)
      WRITE(10,*)
      ELSE
      ENDIF
5300  ALFH=0.0          
      Z=0.0
      ZEXP=0.0
      ZRAND=0.0
      EHCAL2=0.0
      EHOBS2=0.0
      PNSIZ=0.0
      SN=2.0*SGM23
      SGM2=SGM23*SGM23
      DO 5400 I=1,NRSATE
         IF(MARK(I).LT.0) GOTO 5400
         TH=0.0
         BH=0.0
         ALFAXP=0.0
         ALFAAN=0.0
         SUMEHP=0.0
         SUMEPS=0.0
         SUMEPC=0.0
         EH=ES(I)
         EH2=EH*EH
         EPER=EH/EMAXS
         DO 5500 ITH=1,MMM(I)
            JTH=2*ITH
            IR1=IREL(JTH-1,I)
            IR2=IREL(JTH,I)
            JM1=PHS(1,IR1)
            JM2=PHM(1,IR2)
            IPHASAT=PHSATE(JM1)+PHS(2,IR1)
            IPHMA=PHMAIN(JM2)+PHM(2,IR2)
            IPHHP=IPHASAT+IPHMA
            WEHP=WT(JM1)*WTM(JM2)
            EHHP=ES(JM1)*EM(JM2)
            WEHP=WEHP*EHHP
            SKAP2=SGM2*EH2*EHHP*EHHP
            SKAP1=SGM23*EH*EHHP
            IPHHP=MOD(IPHHP,360)+360
            IPHHP=MOD(IPHHP,360)
            ST=SINT(IPHHP)
            CT=COST(IPHHP)
            IF (SKAP1.LE.6.0) THEN
               ALFAXP=ALFAXP+SKAP2*(0.5658-0.1304*SKAP1+0.0106*SKAP2)
            ELSE
               ALFAXP=ALFAXP+SKAP1
            ENDIF
            ALFAAN=ALFAAN+SKAP2
            SUMEHP=SUMEHP+EHHP
            SUMEPS=SUMEPS+EHHP*ST
            SUMEPC=SUMEPC+EHHP*CT
            TH=TH+WEHP*ST
            BH=BH+WEHP*CT
5500            CONTINUE
            ALFH=SN*EH*SQRT(TH*TH+BH*BH)
            Z=Z+ALFH
            ZEXP=ZEXP+ALFAXP
            ZRAND=ZRAND+SQRT(ALFAAN)
            EAL2=SUMEPS*SUMEPS+SUMEPC*SUMEPC
            ECAL(I)=SQRT(EAL2)
            DO J=1,NNNSYM(I)
               EHCAL2=EHCAL2+EAL2
               EHOBS2=EHOBS2+EH2
            END DO
            SMU=SQRT(EHOBS2)/SQRT(EHCAL2)
            IF(EPER.LT.PZPER) THEN
               PSIZ(NSET)=PSIZ(NSET)+ECAL(I)*SMU
               PNSIZ=PNSIZ+1.0
            ELSE
            ENDIF
5400  CONTINUE
      ABSFOM(NSET)=(Z-ZRAND)/(ZEXP-ZRAND)
      ABSF(NSET)=ABSFOM(NSET)
      IF(PNSIZ.NE.0.0) THEN
         PSI(NSET)=PSIZ(NSET)/PNSIZ
         PSIZ(NSET)=PSI(NSET)
      ELSE
      ENDIF
      SMU=SQRT(EHOBS2)/SQRT(EHCAL2)
      XRK=0.0
      YRK=0.0
      DO 5600 I=1,NRSATE
         XRK=XRK+ABS(ES(I)-ECAL(I)*SMU)
         YRK=YRK+ES(I)
5600  CONTINUE
      RKARL(NSET)=XRK/YRK
      RKAR(NSET)=RKARL(NSET)
      RETURN
      END
C      ****** SUB-CFOM ******
      SUBROUTINE CFOM
      LOGICAL ALL
      INTEGER*2 MMM(1000),IREL(600,1000)
      INTEGER*2 MARK(1000),NNNSYM(1000)
      INTEGER*2 HS(4,1000),HM(4,1000),H4S(10000)
      INTEGER*2 HSUM(3),OMIGS(3),MX(4,4,60)
      INTEGER*2 IATOM(50),ZATOM(50),NSETRC(100)
      INTEGER*2 PHS(2,10000),PHM(2,10000)
      INTEGER*2 PHSATE(1000),PHMAIN(1000),PHSATE0(1000),PHNF(1000)
      INTEGER*2 ZER,ZERPI,PI,ICENT,FINE,RADIUS,PORID(4)
      INTEGER*4 H123S(10000),H123M(10000),H(4)
      REAL KPMAX,KPMIN
      COMMON /CZ0/NDIM,ISTD,MFS,MFSGO,ZERPI,ZER,PI,NRTOTAL
      COMMON /CZ1/HSUM,OMIGS,H,FINE,RADIUS,PORID
      COMMON /CZ2/MREL,MREL2,KPMAX,EMKAPMIN,ESKAPMIN,KPMIN,ISIGMA2
      COMMON /CZ3/NTRIAL,ISKIP,W1,W2,W3,MAXCYCL,CYCLCTR,PZPER
      COMMON /CZ4/ICOMP,INDIC,IOVER,NSETRC
      COMMON /CZ5/NATOM,ZATOM,IATOM,SGM23
      COMMON /CZ10/WT(1000),WTM(1000)
      COMMON /RFLX/  NREFS,NREFM,NRSATE,NRMAIN
      COMMON /RFLXM/ HM,EM(1000),FM(1000),SIGFM(1000),PHMAIN,PHM,H123M
      COMMON /RFLXS/ HS,ES(1000),FS(1000),SIGFS(1000),PHSATE,PHS,H123S
     *              ,H4S,PHSATE0
      COMMON /CZ13/EMAXS
      COMMON /CZ14/IREL,MMM,TOTREL
      COMMON /CZ15/SINT(0:450),COST(0:450)
      COMMON /CZ16/IXR,IYR,NFSET,NSET,NFXST
      COMMON /CZ17/ABSFOM(100),PSIZ(100), RKARL(100),COFOM(100),
     *              ABSF(100),PSI(100),RKAR(100),PHNF,WTNF(1000)
      COMMON /CZ18/ABMAX,ABMIN,PSIMAX,PSIMIN,RKAMAX,RKAMIN
      COMMON /CZ19/MX,NRGEN,NSYM,TRANL(4,60),ICENT
      COMMON /CZ20/IALTER,NNNSYM
      COMMON /CZ21/MARK
 
6010  NUMB=NTRIAL
6013  IF(NUMB.LE.1) GOTO 6030
      NUMB=NUMB/2
      IEND=NTRIAL-NUMB
6014      ALL=.TRUE.
      DO 6015 ITOP=1,IEND
         IBOT=ITOP+NUMB
         X=ABSF(ITOP)
         Y=ABSF(IBOT)
         IF(X.LE.Y) GOTO 6015
         AB=ABSF(ITOP)
         ABSF(ITOP)=ABSF(IBOT)
         ABSF(IBOT)=AB
         ALL=.FALSE.
6015      CONTINUE
      IF(.NOT.ALL) THEN
         GOTO 6014
      ELSE
         GOTO 6013
      ENDIF
      GOTO 6013
 
6030  NUMB=NTRIAL
6033  IF(NUMB.LE.1) GOTO 6060
      NUMB=NUMB/2
      IEND=NTRIAL-NUMB
6034      ALL=.TRUE.
      DO 6035 ITOP=1,IEND
         IBOT=ITOP+NUMB
         X=PSI(ITOP)
         Y=PSI(IBOT)
         IF(X.LE.Y) GOTO 6035
         PS=PSI(ITOP)
         PSI(ITOP)=PSI(IBOT)
         PSI(IBOT)=PS
         ALL=.FALSE.
6035  CONTINUE
      IF(.NOT.ALL) THEN
         GOTO 6034
      ELSE
         GOTO 6033
      ENDIF
      GOTO 6033
 
6060  NUMB=NTRIAL
6063  IF(NUMB.LE.1) GOTO 6090
      NUMB=NUMB/2
      IEND=NTRIAL-NUMB
6064      ALL=.TRUE.
      DO 6065 ITOP=1,IEND
         IBOT=ITOP+NUMB
         X=RKAR(ITOP)
         Y=RKAR(IBOT)
         IF(X.LE.Y) GOTO 6065
         RKR=RKAR(ITOP)
         RKAR(ITOP)=RKAR(IBOT)
         RKAR(IBOT)=RKR
         ALL=.FALSE.
6065      CONTINUE
      IF(.NOT.ALL) THEN
         GOTO 6064
      ELSE
         GOTO 6063
      ENDIF
      GOTO 6063
 
6090  ABMIN=ABSF(1)
      ABMAX=ABSF(NTRIAL)
      IF((ABMAX-ABMIN).EQ.0.0) THEN
         ABXN=0.0
         WRITE(10,*)
         WRITE(10,*)
      ELSE
         ABXN=1.0/(ABMAX-ABMIN)      
      ENDIF
      PSIMIN=PSI(1)
      PSIMAX=PSI(NTRIAL)
      IF((PSIMAX-PSIMIN).EQ.0.0) THEN
         PSIXN=0.0
         WRITE(10,*)
         WRITE(10,*)
      ELSE
         PSIXN=1.0/(PSIMAX-PSIMIN)
      ENDIF
      RKAMIN=RKAR(1)
      RKAMAX=RKAR(NTRIAL)
      IF((RKAMAX-RKAMIN).EQ.0.0) THEN
         RKAXN=0.0
         WRITE(10,*)
         WRITE(10,*)
      ELSE
         RKAXN=1.0/(RKAMAX-RKAMIN)
      ENDIF
 
      DO 6100 I=1,NTRIAL
         COFOM(I)=W1*(ABSFOM(I)-ABMIN)*ABXN+
     *              W2*(PSIMAX-PSIZ(I))*PSIXN+
     *              W3*(RKAMAX-RKARL(I))*RKAXN      
6100  CONTINUE
 
      WRITE(10,6102) MAXCYCL
6102  FORMAT(1x,'SUMMRY OF FOMS WITH ',I3,' CYCLES REFINEMENT')
      WRITE(10,*)
      WRITE(10,6103)
6103  FORMAT(1X,'NUMSET      ABSFOM     PSIZERO       ',
     *            'RESID       COFOM')
 
C      SELECT THE BEST SET
6110  NUMB=NTRIAL
6113  IF(NUMB.LE.1) GOTO 6155
      NUMB=NUMB/2
      IEND=NTRIAL-NUMB
6114      ALL=.TRUE.
      DO 6115 ITOP=1,IEND
         IBOT=ITOP+NUMB
         X=COFOM(IBOT)
         Y=COFOM(ITOP)
         IF(X.LE.Y) GOTO 6115
         COF=COFOM(ITOP)
         COFOM(ITOP)=COFOM(IBOT)
         COFOM(IBOT)=COF
         FMABF=ABSFOM(ITOP)
         ABSFOM(ITOP)=ABSFOM(IBOT)
         ABSFOM(IBOT)=FMABF
         PSCOF=PSIZ(ITOP)
         PSIZ(ITOP)=PSIZ(IBOT)
         PSIZ(IBOT)=PSCOF
         RKCOF=RKARL(ITOP)
         RKARL(ITOP)=RKARL(IBOT)
         RKARL(IBOT)=RKCOF
         NSRC=NSETRC(ITOP)
         NSETRC(ITOP)=NSETRC(IBOT)
         NSETRC(IBOT)=NSRC
         ALL=.FALSE.
6115  CONTINUE
      IF(.NOT.ALL) THEN
         GOTO 6114
      ELSE
         GOTO 6113
      ENDIF
      GOTO 6113
 
6155  DO 6109 I=1,NTRIAL
         WRITE(10,6108) (NSETRC(I)+ISKIP),ABSFOM(I),PSIZ(I),
     *                    RKARL(I),COFOM(I)
6109  CONTINUE
6108  FORMAT(1X,I6,F12.3,F12.3,F12.3,F12.3)
      RETURN
      END
C       ****** SUB. FOR CALCULATING MATRIX ****** 
      SUBROUTINE MATRIX
      PARAMETER (ND=4,N=60)
      INTEGER*2 T(ND,ND),MX(ND,ND,N)
      REAL TRAL(ND)
      REAL GP(ND),WCC(ND),WTT(ND)
      REAL*8 WC(N),X,WTS
      COMMON /CZ19/MX,NRGEN,NSYM,TRANL(4,60)
      DATA GP/0.1,0.2,0.3,0.4/
      NK=NRGEN
      CALL WCMAT(MX,GP,ND,N,NRGEN,WC,WCC)
100      NKKK=NK
      DO 200 I=1,NKKK
      DO 300 J=1,NKKK
      DO 400 L=1,ND
        TRAL(L)=0.0
        DO K=1,ND
          T(L,K)=0
          DO M=1,ND
            T(L,K)=T(L,K)+MX(L,M,I)*MX(M,K,J)   
          END DO
        END DO
        DO KL=1,ND
          TRAL(L)=TRAL(L)+MX(L,KL,I)*TRANL(KL,J)
        END DO
        TRAL(L)=TRAL(L)+TRANL(L,I)
        CALL NORMAL(TRAL(L))
400   CONTINUE
      CALL WTMAT(T,GP,ND,WTS,WTT)
      DO 410 II=1,NKKK
          IF(ABS(WC(II)-WTS).GT.1.E-1) GOTO 410
          DO IJ=1,ND
            IF(ABS(TRAL(IJ)-TRANL(IJ,II)).GT.1.E-6) GOTO 410
          END DO
          GOTO 300
410   CONTINUE
      NK=NK+1
      IF(NK.GT.N) GOTO 1000
      WC(NK)=WTS
      CALL CEQT(MX,T,ND,N,NK)
      DO ITS=1,ND
         TRANL(ITS,NK)=TRAL(ITS)
      END DO
      GOTO 100
300   CONTINUE
200   CONTINUE
1000  NSYM=NK
      RETURN
      END
C      *** SUB ***
      SUBROUTINE WTMAT(A,GP,ND,WA,WAA)
      INTEGER*2 A(ND,ND)
      REAL GP(ND),WAA(ND)
      REAL*8 WA
      DO 2000 I=1,ND
         WAA(I)=0.0
      DO 2100 J=1,ND
         WAA(I)=WAA(I)+A(I,J)*GP(J)
2100  CONTINUE
2000  CONTINUE
      WA=(5.0+WAA(1))*1.0E6+(5.0+WAA(2))*1.0E4+
     *     (5.0+WAA(3))*1.0E2+(5.0+WAA(4))*1.0      
      RETURN
      END
C      *** SUB ***
      SUBROUTINE WCMAT(A,GP,ND,N,NK,WA,WAA)
      INTEGER*2 A(ND,ND,N)
      REAL GP(ND),WAA(ND)
      REAL*8 WA(N)
      DO 3000 K=1,NK
         WA(K)=0.0
      DO 3100 I=1,ND
         WAA(I)=0.0
      DO 3200 J=1,ND
         WAA(I)=WAA(I)+A(I,J,K)*GP(J)
3200  CONTINUE
3100  CONTINUE
         WA(K)=(5.0+WAA(1))*1.0E6+(5.0+WAA(2))*1.0E4+
     *     (5.0+WAA(3))*1.0E2+(5.0+WAA(4))*1.0
3000  CONTINUE
      RETURN
      END
C      *** SUB ***
      SUBROUTINE CEQT(CC,TT,ND,N,MM)
      INTEGER*2 CC(ND,ND,N),TT(ND,ND)
      DO 4000 I=1,ND
      DO 4100 J=1,ND
         CC(J,I,MM)=TT(J,I)
4100  CONTINUE
4000  CONTINUE
      RETURN
      END
C      *** SUB ***
      SUBROUTINE NORMAL(X)
 100  CONTINUE
      IF(X.GE.1.) THEN
        X=X-1.
      ELSE IF(X.LT.0.) THEN
        X=X+1.
      ELSE
        RETURN
      END IF
      GOTO 100
      END
C      *** SUB ***
      SUBROUTINE END_JOB
      CHARACTER*16 FILE_OUT,FILE_REFL,FILE_SGM2,TTIME*8,DDATE*9
      COMMON /CZ22/FILE_OUT,FILE_REFL,FILE_SGM2
      CALL TIME(TTIME)
      CALL DATE(DDATE)
      WRITE(10,55) TTIME,DDATE
   55 FORMAT(' *** JOB ended at  'A8,'  ',A9,'  ***')
      WRITE(*,10) TTIME
 10   FORMAT('                                  ended at  ',A8)
      WRITE(*,*)
      WRITE(*,*) '                   Results are stored in the ',
     *             'following files:'
      WRITE(*,*)
      WRITE(*,20) FILE_OUT
      WRITE(*,30) FILE_REFL
      WRITE(*,40) FILE_SGM2
 20   FORMAT(14X,A16,'   (a complete listing)')
 30   FORMAT(14X,A16,'   (reflections with derived phases)')
 40   FORMAT(14X,A16,'   (sigma-2 relationships for later use)')  
      RETURN
      END
