//***************************************************************************
//    Converting one-line symbols to two-line symbols of (3+1)-dimensional 
//                             superspace groups                             
//
//                                 2009.02.16  
//***************************************************************************


#include <string.h>
#include <stdio.h>
#include <math.h>
#include <Windows.h>
#include <process.h>



int SLine1To2(char* Symbol)
{

	//Symbol:  sg0 sg1 sg2 sg3(q1 q2 q3)e1 e2 e3 :UAxis
	char sg0[8]="",sg1[8]="",sg2[8]="",sg3[8]="";
	char q1[8]="",q2[8]="",q3[8]="";
	char e1[8]="",e2[8]="",e3[8]="",e4[8]="";
	char UAxis[8]="";

	int len=strlen(Symbol);
	char p1[256]="";
	char p2[256]="";
	char p3[256]="";
	char temp[2]=" ";
	int i,flag=0;
	for(i=0;i<len;i++)
	{
		if(Symbol[i]=='('|| Symbol[i]==')' ) 
		{
			flag++;
			continue;
		}
		temp[0]=Symbol[i];
		if(flag==0) strcat(p1,temp);
		if(flag==1) strcat(p2,temp);
		if(flag==2) strcat(p3,temp);

	}
	if(flag<2) return 0;
	
	sscanf(p1,"%s %s %s %s",sg0,sg1,sg2,sg3);
	sscanf(p2,"%s %s %s",q1,q2,q3);
	sscanf(p3,"%s %s %s %s",e1,e2,e3,e4);

	char BravaisType;
	//P: (0 0 0)
	if((q1[0]=='0' || q1[0]=='a'  || q1[0]=='A')&&(q2[0]=='0' || q2[0]=='b'|| q2[0]=='B')&&(q3[0]=='0' || q3[0]=='g' || q3[0]=='G')) BravaisType='P';
	//A: (1/2 0 0)
	else if((strcmp(q1,"1/2")==0)&&(q2[0]=='0' || q2[0]=='b' || q2[0]=='B')&&(q3[0]=='0' || q3[0]=='g' || q3[0]=='G')) BravaisType='A';
	//B: (0 1/2 0)
	else if((q1[0]=='0' || q1[0]=='a' || q1[0]=='A')&&(strcmp(q2,"1/2")==0)&&(q3[0]=='0' || q3[0]=='g' || q3[0]=='G')) BravaisType='B';
	//C: (0 0 1/2)
	else if((q1[0]=='0' || q1[0]=='a' || q1[0]=='A')&&(q2[0]=='0' || q2[0]=='b' || q2[0]=='B')&&(strcmp(q3,"1/2")==0)) BravaisType='C';
	//L: (1 0 0)
	else if((strcmp(q1,"1")==0)&&(q2[0]=='0' || q2[0]=='b' || q2[0]=='B')&&(q3[0]=='0' || q3[0]=='g' || q3[0]=='G')) BravaisType='L';
	//M: (0 1 0)
	else if((q1[0]=='0' || q1[0]=='a'|| q1[0]=='A')&&(strcmp(q2,"1")==0)&&(q3[0]=='0' || q3[0]=='g' || q3[0]=='G')) BravaisType='M';
	//N: (0 0 1)
	else if((q1[0]=='0' || q1[0]=='a'|| q1[0]=='A')&&(q2[0]=='0' || q2[0]=='b' || q2[0]=='B')&&(strcmp(q3,"1")==0)) BravaisType='N';
	//U: (0 1/2 1/2)
	else if((q1[0]=='0' || q1[0]=='a' || q1[0]=='A')&&(strcmp(q2,"1/2")==0)&&(strcmp(q3,"1/2")==0)) BravaisType='U';
	//V: (1/2 0 1/2)
	else if((strcmp(q1,"1/2")==0)&&(q2[0]=='0' || q2[0]=='b' || q2[0]=='B')&&(strcmp(q3,"1/2")==0)) BravaisType='V';
	//W: (1/2 1/2 0)
	else if((strcmp(q1,"1/2")==0)&&(strcmp(q2,"1/2")==0)&&(q3[0]=='0' || q3[0]=='g' || q3[0]=='G')) BravaisType='W';
	//R: (1/3 1/3 0)
	else if((strcmp(q1,"1/3")==0)&&(strcmp(q2,"1/3")==0)&&(q3[0]=='0' || q3[0]=='g' || q3[0]=='G')) BravaisType='R';

	char pg1[8]="",pg2[8]="",pg3[8]="";
	char *se[12]={"a","b","c","d","n","m","A","B","C","D","N","M"};
	strcpy(pg1,sg1);
	strcpy(pg2,sg2);
	strcpy(pg3,sg3);
	char *p=NULL;
	for(i=0;i<12;i++)
	{
		p=strstr(pg1,se[i]);
		if(p) *p='m';
		p=NULL;
		p=strstr(pg2,se[i]);
		if(p) *p='m';
		p=NULL;
		p=strstr(pg3,se[i]);
		if(p) *p='m';
		p=NULL;
	}

	char* lpg[3]={pg1,pg2,pg3};
	for(i=0;i<3;i++)
	{
		if(strcmp(lpg[i],"21")==0) strcpy(lpg[i],"2");
		if(strcmp(lpg[i],"31")==0) strcpy(lpg[i],"3");
		if(strcmp(lpg[i],"32")==0) strcpy(lpg[i],"3");
		if(strcmp(lpg[i],"41")==0) strcpy(lpg[i],"4");
		if(strcmp(lpg[i],"42")==0) strcpy(lpg[i],"4");
		if(strcmp(lpg[i],"43")==0) strcpy(lpg[i],"4");
		if(strcmp(lpg[i],"61")==0) strcpy(lpg[i],"6");
		if(strcmp(lpg[i],"62")==0) strcpy(lpg[i],"6");
		if(strcmp(lpg[i],"63")==0) strcpy(lpg[i],"6");
		if(strcmp(lpg[i],"64")==0) strcpy(lpg[i],"6");
		if(strcmp(lpg[i],"65")==0) strcpy(lpg[i],"6");

		if(strcmp(lpg[i],"21/m")==0) strcpy(lpg[i],"2/m");
		if(strcmp(lpg[i],"31/m")==0) strcpy(lpg[i],"3/m");
		if(strcmp(lpg[i],"32/m")==0) strcpy(lpg[i],"3/m");
		if(strcmp(lpg[i],"41/m")==0) strcpy(lpg[i],"4/m");
		if(strcmp(lpg[i],"42/m")==0) strcpy(lpg[i],"4/m");
		if(strcmp(lpg[i],"43/m")==0) strcpy(lpg[i],"4/m");
		if(strcmp(lpg[i],"61/m")==0) strcpy(lpg[i],"6/m");
		if(strcmp(lpg[i],"62/m")==0) strcpy(lpg[i],"6/m");
		if(strcmp(lpg[i],"63/m")==0) strcpy(lpg[i],"6/m");
		if(strcmp(lpg[i],"64/m")==0) strcpy(lpg[i],"6/m");
		if(strcmp(lpg[i],"65/m")==0) strcpy(lpg[i],"6/m");
	}

		char *pglist_0[37][3]={    //Unique direction: C
		"1","","",      //0 T
		"-1","","",     
		"2","","",      //2 M  
		"m","","",      
		"2/m","","",    
		"2","2","2",    //5 O 
		"m","m","2",
		"2","m","m",
		"m","2","m",
		"m","m","m",
		"4","","",     //10 T
		"-4","","",     
		"4/m","","",    
		"4","2","2",    
		"4","m","m",    
		"-4","2","m",   
		"-4","m","2",   
		"4/m","m","m",  
		"3","","",      
		"-3","","",
		"3","2","",     
		"3","m","",     
		"-3","m","",    
		"3","1","2",    
		"3","2","1",    
		"3","m","1",    
		"3","1","m",    
		"-3","m","1",   
		"-3","1","m",   
		"6","","",      
		"-6","","",     
		"6/m","","",    
		"6","2","2",    
		"6","m","m",    
		"-6","m","2",   
		"-6","2","m",   
		"6/m","m","m"};

	int pgsign_0[37][4]={
		1,   0,   0,   0, 
		-1,   0,   0,   0, 
		1,   0,   0,   0, 
		-1,   0,   0,   0, 
		1,  -1,   0,   0, 
		-1,  -1,   1,   0, 
		1,   1,   1,   0, 
		-1,   1,  -1,   0, 
		1,  -1,  -1,   0, 
		1,   1,  -1,   0, 
		1,   0,   0,   0, 
		-1,   0,   0,   0, 
		1,  -1,   0,   0, 
		1,  -1,  -1,   0, 
		1,   1,   1,   0, 
		-1,  -1,   1,   0, 
		-1,   1,  -1,   0, 
		1,  -1,   1,   1, 
		1,   0,   0,   0, 
		-1,   0,   0,   0, 
		1,  -1,   0,   0, 
		1,   1,   0,   0, 
		-1,   1,   0,   0, 
		1,   1,  -1,   0, 
		1,  -1,   1,   0, 
		1,   1,   1,   0, 
		1,   1,   1,   0, 
		-1,   1,   1,   0, 
		-1,   1,   1,   0, 
		1,   0,   0,   0, 
		-1,   0,   0,   0, 
		1,  -1,   0,   0, 
		1,  -1,  -1,   0, 
		1,   1,   1,   0, 
		-1,   1,  -1,   0, 
		-1,  -1,   1,   0, 
		1,  -1,   1,   1};

	char *pglist_1[5][3]={  //Unique direction: B
		"2","2","2",
		"m","m","2",
		"2","m","m",
		"m","2","m",
		"m","m","m"};

	int pgsign_1[5][4]={
		-1,   1,  -1,   0,
		1,  -1,  -1,   0,
		-1,  -1,   1,   0,
		1,   1,   1,   0,
		1,  -1,   1,   0};

	char *pglist_2[5][3]={  //Unique direction: A
		"2","2","2",
		"m","m","2",
		"2","m","m",
		"m","2","m",
		"m","m","m"};

	int pgsign_2[5][4]={
		1,  -1,  -1,   0,
		-1,   1,  -1,   0,
		1,   1,   1,   0,
		-1,  -1,   1,   0,
		-1,   1,   1,   0};

	
    
	
	for(i=0;i<37;i++)
	{
		if(strcmp(pglist_0[i][0],pg1)==0 && strcmp(pglist_0[i][1],pg2)==0 &&strcmp(pglist_0[i][2],pg3)==0) break;
	}

	if(i==37) return 0;

	
	flag=0;
	if(strcmp(q1,"a")==0 || strcmp(q1,"A")==0) flag+=1;
	if(strcmp(q2,"b")==0 || strcmp(q2,"B")==0) flag+=2;
	if(strcmp(q3,"g")==0 || strcmp(q3,"G")==0) flag+=4;

	if(flag==0) return 0;
	if(flag==1) strcpy(UAxis,":A");
	if(flag==2) strcpy(UAxis,":B");
	if(flag==6) strcpy(UAxis,":A");
	if(flag==5) strcpy(UAxis,":B");

	
	int (*pgsign)[4];
	int M1or2=1;
	
	if(i<2) 
	{
		if(flag!=7) return 0;
		pgsign=pgsign_0;
	}

	
	if(i>1 && i<5)
	{
		if(flag==7) return 0;
		pgsign=pgsign_0;
		if(flag==3 || flag==5 || flag==6) M1or2=-1;
	}

	
	if(i>4 && i<10)
	{
		if(flag!=1 && flag!=2 && flag!=4) return 0;

		if(flag==4) pgsign=pgsign_0;

		if(flag==2) 
		{
			pgsign=pgsign_1;
			for(i=0;i<5;i++)
			{
				if(strcmp(pglist_1[i][0],pg1)==0 && strcmp(pglist_1[i][1],pg2)==0 &&strcmp(pglist_1[i][2],pg3)==0) break;
			}
			if(i==5) return 0;

		}

		if(flag==1) 
		{
			pgsign=pgsign_2;
			for(i=0;i<5;i++)
			{
				if(strcmp(pglist_2[i][0],pg1)==0 && strcmp(pglist_2[i][1],pg2)==0 &&strcmp(pglist_2[i][2],pg3)==0) break;
			}
			if(i==5) return 0;
		}

	}

	if(i>9)
	{
		if(flag!=4) return 0;
		pgsign=pgsign_0;
	}

	
	if((strcmp(e1,"")==0 || strcmp(e1,"0")==0) && (pgsign[i][0]!=0)) ((pgsign[i][0]*M1or2)==1)?strcpy(e1,"1"):strcpy(e1,"-1");
	if((strcmp(e2,"")==0 || strcmp(e2,"0")==0) && (pgsign[i][1]!=0)) ((pgsign[i][1]*M1or2)==1)?strcpy(e2,"1"):strcpy(e2,"-1");
	if((strcmp(e3,"")==0 || strcmp(e3,"0")==0) && (pgsign[i][2]!=0)) ((pgsign[i][2]*M1or2)==1)?strcpy(e3,"1"):strcpy(e3,"-1");
	if((strcmp(e4,"")==0 || strcmp(e4,"0")==0) && (pgsign[i][3]!=0)) ((pgsign[i][3]*M1or2)==1)?strcpy(e4,"1"):strcpy(e4,"-1");

	
	char result[256]=" ";
	result[0]=BravaisType;

	strcat(result,"[");
	strcat(result,sg0);
	if(strlen(sg1)>0) 
	{
		strcat(result," ");
		strcat(result,sg1);
	}
	if(strlen(sg2)>0) 
	{
		strcat(result," ");
		strcat(result,sg2);
	}
	if(strlen(sg3)>0) 
	{
		strcat(result," ");
		strcat(result,sg3);
	}
	strcat(result,"]");

	if(strlen(e1)>0) 
	{
		strcat(result,e1);
		strcat(result," ");
	}
	if(strlen(e2)>0) 
	{
		strcat(result,e2);
		strcat(result," ");
	}
	if(strlen(e3)>0) 
	{
		strcat(result,e3);
		strcat(result," ");
	}
	if(strlen(e4)>0) 
	{
		strcat(result,e4);
		strcat(result," ");
	}
	
	strcat(result,UAxis);

	strcpy(Symbol,result);

	return 1;

}

int main()
{
	char Symbol[256]="";
	int count=0;
	while(1)
	{
		printf("%s","Input symbol: ");
		gets(Symbol);
		if(strcmp(Symbol,"exit")==0|| strcmp(Symbol,"EXIT")==0) break;

		int flag=SLine1To2(Symbol);

		if(flag!=0)  printf("Two-line symbol: %s\n\n",Symbol);


		FILE *fp;
		if((fp=fopen("~VECSPGR.IN","wt"))==NULL)
		{
			printf("Cannot create temporary file. ");
			exit(1);
		}
		fprintf(fp,"%s\n",Symbol);
		fclose(fp);

		// Clear OUT.TXT file in the first run
		if(count==0)
		{
			fp=fopen("OUT.TXT","wt");
			fclose(fp);
			count=1;
		}	

		// Output to file
		keybd_event(13,0,0,0); 	
		system("SPGR4D >>OUT.TXT");

		fp=fopen("OUT.TXT","r+");
		long offset=28;
		fseek(fp,-1*offset,SEEK_END);

		while(offset>0)
		{
			putc(' ',fp);
			offset--;
		}
		fclose(fp);

		// Output to window
		system("SPGR4D");

		system("del ~VECSPGR.OUT");
		system("del ~VECSPGR.IN");

		

	}


	return 1;
	

}